%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%Avoid visualizing the wrong waitbar
global pick
pick = tau_total;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%              Begin numerical computation
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
S_vec_o(1) = str2num(get(handles.edit_S01,'String'));  
S_vec_o(2) = str2num(get(handles.edit_S02,'String'));
S_vec_o(3) = str2num(get(handles.edit_S03,'String'));  % Relative equilibrium
D_vec_o(1) = str2num(get(handles.edit_D01,'String'));  %      position
D_vec_o(2) = str2num(get(handles.edit_D02,'String'));
D_vec_o(3) = str2num(get(handles.edit_D03,'String'));
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
RotS3 = S_vec_o/norma(S_vec_o);
if (S_vec_o(2)^2+S_vec_o(3)^2) == 0
    RotS2 = [0  1  0];
    RotS1 = [0  0 -1];
else
    RotS2 = [0  S_vec_o(3)/sqrt(S_vec_o(2)^2+S_vec_o(3)^2)...
        -S_vec_o(2)/sqrt(S_vec_o(2)^2+S_vec_o(3)^2)];
    RotS1 = vectorp(RotS2, RotS3);
end
RotS = [RotS1' RotS2' RotS3'];
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
RotD3 = D_vec_o/norma(D_vec_o);
if (D_vec_o(2)^2+D_vec_o(3)^2) == 0
    RotD2 = [0  1  0];
    RotD1 = [0  0 -1];
else
    RotD2 = [0  D_vec_o(3)/sqrt(D_vec_o(2)^2+D_vec_o(3)^2)...
        -D_vec_o(2)/sqrt(D_vec_o(2)^2+D_vec_o(3)^2)];
    RotD1 = vectorp(RotD2, RotD3);
end
RotD = [RotD1' RotD2' RotD3'];
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
sm_ax_o = 1;
f_o =   0;
omega_o = str2num(get(handles.edit_LGG3_perprime,'String'));
G_init = str2num(get(handles.edit_Init_Gprime,'String'));
G_final = str2num(get(handles.edit_Final_Gprime,'String'));
row_tot = str2num(get(handles.edit_Step_Gprime,'String')) + 1;
G3_init = str2num(get(handles.edit_Init_G3prime,'String'));
G3_final = str2num(get(handles.edit_Final_G3prime,'String'));
col_tot = str2num(get(handles.edit_Step_G3prime,'String')) + 1;

int_tot = min(row_tot, col_tot);
ext_tot = max(row_tot, col_tot);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%            Integrate a single orbit
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
if (row_tot == 1) & (col_tot == 1)

    if (abs(G3_init) > G_init) &...
            (strcmp(get(handles.warningbox, 'Checked'),'on'))
        errordlg(['The vertical projection | G3 | cannot be greater than G.  ']);
        return
    end

    sm_ax_o = 1;
    omega_o = str2num(get(handles.edit_LGG3_perprime,'String'));
    f_o =   0;
    G_vec_prime = [0  -sqrt(G_init^2-G3_init^2)  G3_init];
    if G_init == 0
        warndlg(sprintf(['Null angular momentum => inclination undefined.']))
        return
    else
        R_vec_prime = sqrt(sm_ax_o-G_init^2)*[cos(pi/180*omega_o)  sin(pi/180*omega_o)*G3_init/G_init  ...
            sin(pi/180*omega_o)*sqrt(1- G3_init^2/G_init^2)];
    end
    S_vec_prime = 1/2*(G_vec_prime + R_vec_prime);
    D_vec_prime = 1/2*(G_vec_prime - R_vec_prime);
    S_vec = S_vec_prime*RotS';
    D_vec = D_vec_prime*RotD';
    [q_vec_o, p_vec_o] = SD2Cartesian(S_vec, D_vec);

%-------------------------------------------------------------------------------
    lambd = lambda_tot + 1;
    clear global lambda
    kk = 0;
    while abs(lambd - lambda_tot) > 1e-02
        if kk > 50
            break
        end
        lambd = 1/sqrt(-2*(1/2*p_vec_o*p_vec_o' - 1/sqrt(q_vec_o*q_vec_o')...
            + Hp(q_vec_o, p_vec_o, epsilon1, epsilon2, epsilon3, epsilon4, epsilon5, Hp1, Hp2, Hp3, Hp4, Hp5)));
            
        if ~isreal(lambd)
            break
        end
            
        q_vec_o = lambda_tot^2*q_vec_o/lambd^2;
        p_vec_o = p_vec_o*lambd/lambda_tot;
        kk = kk + 1;
    end
 %{       
    if (~isreal(lambd) | isnan(lambd))
        [q_vec_o, p_vec_o] = SD2Cartesian(S_vec_o/2, D_vec_o/2);
    end
 %}      
    f = @(z)1/sqrt(-2*(1/2*z^2*p_vec_o*p_vec_o' - 1/sqrt(q_vec_o*q_vec_o')*z^2 ...
            + Hp(q_vec_o/z^2, p_vec_o*z, epsilon1, epsilon2, epsilon3, epsilon4, epsilon5, Hp1, Hp2, Hp3, Hp4, Hp5))) - lambda_tot;
    opts = optimset('Display','off');
    
    try
        a = fzero(f,1,opts);
    catch
        warndlg(sprintf(['With the selected value of Total Energy I am not able to find the initial conditions.']))
        return
    end

    if isnan(a)
        warndlg(sprintf(['With the selected value of Total Energy it is impossible to find ',...
          'the initial conditions for a correct value of G and G3.']))
        return
    end                  
    q_vec_o = q_vec_o/a^2;
    p_vec_o = p_vec_o*a;
    clear global lambda
%---------------------------------------------------------------------
    set(handles.q1_value,'String', q_vec_o(1))
    set(handles.q2_value,'String', q_vec_o(2))
    set(handles.q3_value,'String', q_vec_o(3))
    set(handles.p1_value,'String', p_vec_o(1))
    set(handles.p2_value,'String', p_vec_o(2))
    set(handles.p3_value,'String', p_vec_o(3))
    Cartesian2Keplerian

    set(handles.edit_smaxis,'String', num2str(sm_ax_o,'%5.10f'))
    set(handles.edit_Eccentricity,'String', num2str(Ecc_o,'%5.10f'))
    set(handles.edit_AscNode,'String', num2str(Omega_o,'%5.10f'))
    set(handles.edit_ArgPericenter,'String', num2str(omega_o,'%5.10f'))
    set(handles.edit_Inclination,'String', num2str(incl_o,'%5.10f'))
    set(handles.edit_TrueAnomaly,'String', num2str(f_o,'%5.10f'))

    Disable_General

    set(handles.uipanel_Freq3D_LGG3, 'Visible', 'off')
    set(handles.uipanelInit, 'Visible', 'on')
    set(handles.uipanel_AA_FMFT, 'Visible', 'on')
    set(handles.uipanel_RegMethod, 'Visible', 'on')
    set(handles.uipanel_StandMethod, 'Visible', 'on')    
    set(handles.uipanel_ClearMemory,'Visible', 'on')    
    set(handles.radiobutton_1st,'Value', 1)
    set(handles.radiobutton_2nd,'Value', 0)
    set(handles.radiobutton_Delaunay,'Value', 0)
    set(handles.radiobutton_Delaunayprime,'Value', 1)
    set(handles.radiobutton_Pauli,'Value', 0)
    set(handles.radiobutton_Pauliprime,'Value', 0)
    ValuePert = get(handles.radiobutton_Pert_LGG3,'Value');
    ValueNonPert = get(handles.radiobutton_NonPert_LGG3,'Value');
    set(handles.radiobutton_Pert,'Value', ValuePert)
    set(handles.radiobutton_NonPert,'Value', ValueNonPert)
    set(handles.edit_block,'Visible', 'on')
    set(handles.text_block,'Visible', 'on')
    set(handles.popupmenu_head,'Value', 1)
      
    if strcmp(get(handles.LGG3_long_FMFT, 'Checked'),'on') |...
                strcmp(get(handles.LSD_long_FMFT, 'Checked'),'on')
        set(handles.uipanel_from_to,'Visible', 'off')
        set(handles.LongtimeFA,'Visible', 'on')
    else      
        set(handles.uipanel_from_to, 'Visible', 'on')
        set(handles.LongtimeFA, 'Visible', 'off')
    end
    
    pushbutton_Integrate_Callback(hObject, eventdata, handles)
%    Integrate
    return
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%             Integrate a grid of initial values
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
display('                                                                 ')
display('###################################################################')
display(['    STARTING COMPUTATION with ',ODE,'!!!'])
disp('    ')
tic
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
if isdeployed
    % do nothing
else
    if get(handles.radiobutton_Pert_LGG3,'Value') == 1
        Symbolic
        Write2file
        waitfor(exist('DiffEquation'))
    elseif get(handles.radiobutton_NonPert_LGG3,'Value') == 1
        SymbolicNonPert
        Write2fileNonPert
        waitfor(exist('DiffEquation'))
    end
end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%{
if (row_tot > 1) & (col_tot > 1) & (max(abs(G3_init), abs(G3_final)) >= min(G_init, G_final)) &...
        (strcmp(get(handles.warningbox, 'Checked'),'on'))
    warndlg('The (unphysical) points with | G3 | > G will be left blank.');
end
%}
if row_tot == 1
    stepG = 0;
    %{
    if (max(abs(G3_init), abs(G3_final)) >= G_init) &...
            (strcmp(get(handles.warningbox, 'Checked'),'on'))
        warndlg('The (unphysical) points with | G3 | > G will be left blank.');
    end
    %}
else
    stepG = (G_final- G_init)/(row_tot - 1);
end

if col_tot == 1
    stepG3 = 0;
    %{
    if (abs(G3_init) >= min(G_init, G_final)) &...
            (strcmp(get(handles.warningbox, 'Checked'),'on'))
        warndlg('The (unphysical) points with | G3 | > G will be left blank.');
    end
    %}
else
    stepG3 = (G3_final - G3_init)/(col_tot - 1);
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
if strcmp(ODE, 'Tom') == 1
    met = str2num(get(handles.edit_met,'String'));
    StepSize = str2num(get(handles.edit_StepSize,'String'));
    RelTolNewt = str2num(get(handles.edit_RelTolNewt,'String'));
    Itnlmax = str2num(get(handles.edit_Itnlmax,'String'));
    tom_options = tomgset('met',met,'Order',10,'StepSize',StepSize,...
        'RelTolNewt',RelTolNewt,...
        'Vectorized','off','OutputSteps',1,...
        'Itnlmax',Itnlmax,'Stats_step','off','Stats','off');
    options = tom_options;
elseif (strcmp(ODE, 'RungeKutta4') == 1) | (strcmp(ODE, 'RungeKutta5') == 1)
    StepSize = str2num(get(handles.edit_FixedStepSize,'String'));
    tau_c = (0 : StepSize : tau_total)';
    options = struct([]);
elseif (strcmp(ODE, 'IRKGauss') == 1)
    StepSize = str2num(get(handles.edit_FixedStepSize,'String'));
    opt.method = str2num(get(handles.edit_IRKMeth,'String'));
    opt.nstep = tau_total/StepSize;
    options = struct([]);
else
    Rel_Tol = str2num(get(handles.edit_RelTol,'String'));
    Abs_Tol = str2num(get(handles.edit_AbsTol,'String'));
    Init_Step = str2num(get(handles.edit_InitialStep,'String'));
    Max_Step = str2num(get(handles.edit_MaxStep,'String'));
    options = odeset('InitialStep',[Init_Step], 'Maxstep',[Max_Step],...
        'RelTol',[Rel_Tol], 'AbsTol',[Abs_Tol]);            
end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
begin = datestr(now, 'dd mmm HH:MM');
if ~isnan(findstr(KeplerDir, 'Slave'))
    % do nothing
else
%    if strcmp(get(handles.waitbars, 'Checked'),'on')
        mainbar = waitbar(0,'Please wait..., KEPLER is calculating.');
%    else
%        mainbar = [];
%    end
end
%---------------------- Start multicore -----------------------------------
parameterCell = cell(1,ext_tot);
subcell = cell(1,12);
for ext = 1:ext_tot
    subcell{1,1} = [ext];
    subcell{1,2} = [stepG];
    subcell{1,3} = [stepG3];
    subcell{1,4} = [RotS];
    subcell{1,5} = [RotD];
    subcell{1,6} = [];
    subcell{1,7} = [options];
    subcell{1,8} = [S_vec_o];
    subcell{1,9} = [D_vec_o];
    subcell{1,10} = [handles];
    subcell{1,11} = [begin];
    subcell{1,12} = [mainbar];
    parameterCell{1,ext} = {subcell};
end

cd ..
fid = fopen('WaitBar.txt','w');
fwrite(fid,'0');
fclose(fid);
cd(KeplerDir)

resultCell = startmulticoremaster(@parfor_LGG3, parameterCell, '../multicorefiles');
%---------------------- End multicore -----------------------------------
freq_1 = [resultCell{1,1}(1,:)];
for k = 2 : ext_tot
    freq_1 = [freq_1; resultCell{1,k}(1,:)];
end
freq_2 = [resultCell{1,1}(2,:)];
for k = 2 : ext_tot
    freq_2 = [freq_2; resultCell{1,k}(2,:)];
end
freq_3 = [resultCell{1,1}(3,:)];
for k = 2 : ext_tot
    freq_3 = [freq_3; resultCell{1,k}(3,:)];
end
FMI_1 = [resultCell{1,1}(4,:)];
for k = 2 : ext_tot
    FMI_1 = [FMI_1; resultCell{1,k}(4,:)];
end
FMI_2 = [resultCell{1,1}(5,:)];
for k = 2 : ext_tot
    FMI_2 = [FMI_2; resultCell{1,k}(5,:)];
end
FMI_3 = [resultCell{1,1}(6,:)];
for k = 2 : ext_tot
    FMI_3 = [FMI_3; resultCell{1,k}(6,:)];
end

if row_tot <= col_tot
    freq_1 = freq_1';
    freq_2 = freq_2';
    freq_3 = freq_3';
    FMI_1 = FMI_1';
    FMI_2 = FMI_2';
    FMI_3 = FMI_3';
end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%                    Save to file
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
save UserSaved/freq1.dat freq_1 -ascii
save UserSaved/freq2.dat freq_2 -ascii
save UserSaved/freq3.dat freq_3 -ascii
save UserSaved/FMI1.dat FMI_1 -ascii
save UserSaved/FMI2.dat FMI_2 -ascii
save UserSaved/FMI3.dat FMI_3 -ascii
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%         
delete *.txt
%{
if ishandle(mainbar)
    close(mainbar);
end
%}
%set(handles.count,'String', num2str(0));
display('-------------------------------------------------------------------')
display(['            FINISH with ',ODE,'!!!'])
toc
display('###################################################################')
set(handles.count,'String', '0');
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

if row_tot > 1
    G_ = G_init : (G_final - G_init)/(row_tot - 1) : G_final;
end
if col_tot > 1
    G_3 = G3_init : (G3_final - G3_init)/(col_tot - 1) : G3_final;
end

G_string = num2str(G_init);
G3_string = num2str(G3_init);
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%