function varargout = Poincare(varargin)
% POINCARE M-file for Poincare.fig

% Last Modified by GUIDE v2.5 24-May-2012 19:45:14

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
    'gui_Singleton',  gui_Singleton, ...
    'gui_OpeningFcn', @Poincare_OpeningFcn, ...
    'gui_OutputFcn',  @Poincare_OutputFcn, ...
    'gui_LayoutFcn',  [] , ...
    'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT

% --- Executes just before Poincare is made visible.
function Poincare_OpeningFcn(hObject, eventdata, handles, varargin)
global PoincareDir PhSpGeoDir
PoincareDir = cd;
cd ..
cd ..
PhSpGeoDir = cd;
cd(PoincareDir)
if isdeployed
    % do nothing
else
    path([PoincareDir,'/Help'],path);
    path([PhSpGeoDir,'/Util'], path);
    path([PhSpGeoDir,'/Util/Multicore'], path);
    path(PoincareDir, path);
end
%%%%%%%%%%%%%%%%%%% HELP %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
Hfcn=['str=get(gco,''Tag'');'...
      'HelpScript'];
set(handles.figure1,'HelpFcn',Hfcn);
cshelp(handles.figure1);

keyFcn = ['if strcmp(get(gcbo,''CurrentKey''),''escape''), ' ...
              'set(gcbo,''CSHelpMode'',''off''); ' ...
          'elseif strcmp(get(gcbo,''CurrentKey''),''f2''), ' ...
              'set(gcbo,''CSHelpMode'',''on''); ' ...  
          'end'];     
set(handles.figure1,'keyPressFcn',keyFcn);
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

ColorFont
handles.output = hObject;
if ~isnan(findstr(PoincareDir, 'Slave'))
    set(handles.pushbutton_StartSlave, 'Visible', 'on')
    set(handles.pushbutton_Calculate, 'Visible', 'off')
else
    cd ..
    if exist('multicorefiles')
        rmdir('multicorefiles','s')
    end
    cd(PoincareDir)
end

list = strread(cd, '%s','delimiter',strrep(filesep,'\','\\'));
dim = size(list);
%curdir = list{dim(1,1), dim(1,2)};
curdir = [list{dim(1,1), dim(1,2)},' - ',list{dim(1,1) - 1, dim(1,2)}];
set(handles.figure1, 'Name', curdir)
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%                  Load saved on exit
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
cd(PoincareDir)
cd ..
if exist('Setting.mat')
    load('Setting.mat')
    SetInit
end
cd(PoincareDir)

% Update handles structure
guidata(hObject, handles);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
if ~isnan(findstr(PoincareDir, 'Slave'))
    Totalbar = waitbar(0,'Please wait..., POINCARE is calculating.',...
        'Units', 'pixel', 'Position', [392 570 380 70]);
end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% --- Outputs from this function are returned to the command line.
function varargout = Poincare_OutputFcn(hObject, eventdata, handles) 

% Get default command line output from handles structure
varargout{1} = handles.output;

% --- Executes during object deletion, before destroying properties.
function figure1_DeleteFcn(hObject, eventdata, handles)
global PoincareDir PhSpGeoDir
if ~isnan(findstr(PoincareDir, 'Slave'))
%do nothing
else
    if strcmp(get(handles.Save_exit, 'Checked'),'on')     
        cd(PoincareDir)
        InitStructure
        cd ..        
        save('Setting.mat', '-struct', 'InitStr')
        cd(PoincareDir)
    end
end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function step_1_Callback(hObject, eventdata, handles)
if str2num(get(gcbo,'String')) < 1
    warndlg('The entry must be a positive integer','Invalid entry')
    set(gcbo,'String','1')
end

function step_2_Callback(hObject, eventdata, handles)
if str2num(get(gcbo,'String')) < 1
    warndlg('The entry must be a positive integer','Invalid entry')
    set(gcbo,'String','1')
end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% --- Executes on button press in pushbutton_Calculate.
function pushbutton_Calculate_Callback(hObject, eventdata, handles)
x1_in = str2num(get(handles.x1_in,'String'));
x2_in = str2num(get(handles.x2_in,'String'));
x1_fin = str2num(get(handles.x1_fin,'String'));
x2_fin = str2num(get(handles.x2_fin,'String'));
numstep_x1 = str2num(get(handles.step_1,'String'));
numstep_x2 = str2num(get(handles.step_2,'String'));
row_tot = numstep_x2 + 1;
col_tot = numstep_x1 + 1;
ext_tot = max(row_tot, col_tot);
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
begin = datestr(now, 'dd mmm HH:MM');
global PoincareDir PhSpGeoDir
if ~isnan(findstr(PoincareDir, 'Slave'))
% do nothing
else
    Totalbar = waitbar(0,'Please wait..., POINCARE is calculating.',...
        'Units', 'pixel', 'Position', [392 570 380 70]);
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
display('                                                                 ')
display('###################################################################')
display('    STARTING COMPUTATION !!!')
disp('    ')
tic
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%---------------------- Start multicore -----------------------------------
parameterCell = cell(1,ext_tot);
subcell = cell(1,4);
for ext = 1:ext_tot
    subcell{1,1} = [ext];
    subcell{1,2} = [handles];
    subcell{1,3} = [Totalbar];
    subcell{1,4} = [begin];    
    parameterCell{1,ext} = {subcell};
end

cd ..
fid = fopen('WaitBar.txt','w');
fwrite(fid,'0');
fclose(fid);
cd(PoincareDir)

resultCell = startmulticoremaster(@paralfor, parameterCell, '../multicorefiles');
%---------------------- End multicore -----------------------------------
FMI_1 = [resultCell{1,1}(1,:)];
for k = 2 : ext_tot
    FMI_1 = [FMI_1; resultCell{1,k}(1,:)];
end
FMI_2 = [resultCell{1,1}(2,:)];
for k = 2 : ext_tot
    FMI_2 = [FMI_2; resultCell{1,k}(2,:)];
end

if row_tot <= col_tot
    FMI_1 = FMI_1';
    FMI_2 = FMI_2';
end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%                    Save to file
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
save FMI1.dat FMI_1 -ascii
save FMI2.dat FMI_2 -ascii      
delete *.txt
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
x1 = x1_in : (x1_fin - x1_in)/numstep_x1 : x1_fin;
x2 = x2_in : (x2_fin - x2_in)/numstep_x2 : x2_fin;

if str2num(get(handles.Step_FMI1,'String')) > 0;
    figure
    colormap(gray)
    surf(x1, x2, FMI_1, 'FaceColor', 'interp', 'LineStyle', 'none');
    view(2)
    xlabel('\itx_1', 'FontSize',14), ylabel('\itx_2', 'FontSize',14)
    title({'FMI 1'}, 'FontSize',14)
end

if str2num(get(handles.Step_FMI2,'String')) > 0;
    figure
    colormap(gray)
    surf(x1, x2, FMI_2, 'FaceColor', 'interp', 'LineStyle', 'none');
    view(2)
    xlabel('\itx_1', 'FontSize',14), ylabel('\itx_2', 'FontSize',14)
    title({'FMI 2'}, 'FontSize',14)
end

display('-------------------------------------------------------------------')
display('            FINISH !!!')
toc
display('###################################################################')
set(handles.count,'String', '0');

function count_Callback(hObject, eventdata, handles)

function count_CreateFcn(hObject, eventdata, handles)

function pushbutton_StartSlave_Callback(hObject, eventdata, handles)
set(handles.pushbutton_StartSlave, 'Enable', 'off', 'String', 'Slave is running', 'FontSize', 10)
startmulticoreslave('../multicorefiles')

%%%%%%%%%%%%%%%%%%% MENU %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function savesetting_Callback(hObject, eventdata, handles)
% do nothing

function Save_exit_Callback(hObject, eventdata, handles)
if strcmp(get(gcbo, 'Checked'),'on')
    set(gcbo, 'Checked','off');
else
    set(gcbo, 'Checked','on');
end

function Save_now_Callback(hObject, eventdata, handles)
global PoincareDir PhSpGeoDir
InitStructure
cd(PoincareDir)
cd ..        
save('Setting.mat', '-struct', 'InitStr')
cd(PoincareDir)

function save_fig_Callback(hObject, eventdata, handles)
if get(0,'CurrentFigure')
%    set(handles.save_eps,'Enable','on')
    set(handles.save_pdf,'Enable','on')
    set(handles.save_png,'Enable','on')
    set(handles.jpeg2eps,'Enable','on')
else
%    set(handles.save_eps,'Enable','off')
    set(handles.save_pdf,'Enable','off')
    set(handles.save_png,'Enable','off')
    set(handles.jpeg2eps,'Enable','off')
end
%{
function save_eps_Callback(hObject, eventdata, handles)
[pathstr, name, ext] = fileparts(get(gcf, 'FileName'));
if strcmp(name, '')
    savefig('CurrentFigure', 'eps', '-fonts')   
else
    savefig(name, 'eps', '-fonts')
end
%}
function save_pdf_Callback(hObject, eventdata, handles)
[pathstr, name, ext] = fileparts(get(gcf, 'FileName'));
if strcmp(name, '')
    savefig('CurrentFigure', 'pdf', '-fonts')   
else
    savefig(name, 'pdf', '-fonts')
end

function save_png_Callback(hObject, eventdata, handles)
[pathstr, name, ext] = fileparts(get(gcf, 'FileName'));
if strcmp(name, '')
    savefig('CurrentFigure', 'png', '-r1200')   
else
    savefig(name, 'png', '-r1200')
end

function jpeg2eps_Callback(hObject, eventdata, handles)
[pathstr, name, ext] = fileparts(get(gcf, 'FileName'));
global PhSpGeoDir
if strcmp(name, '')
    savefig('CurrentFigure', 'jpeg', '-r1200')
    cmd_string = ['!',PhSpGeoDir,'/Util/jpeg2ps -r 0 CurrentFigure.jpeg > CurrentFigure.eps'];
    eval(cmd_string)
else
    savefig(name, 'jpeg', '-r1200')
    cmd_string = ['!',PhSpGeoDir,'/Util/jpeg2ps -r 0 ',name,'.jpeg > ',name,'.eps'];
    eval(cmd_string)    
end


function Help_Callback(hObject, eventdata, handles)
% do nothing

function EnterHelp_Callback(hObject, eventdata, handles)
set(handles.figure1,'CSHelpMode','on');

function EscHelp_Callback(hObject, eventdata, handles)
set(handles.figure1,'CSHelpMode','off');

function About_Callback(hObject, eventdata, handles)
About

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%                 END of CODE
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
